//=============================================================================
// Character.h
//=============================================================================
#pragma once

#include "NumberAnimation.h"

//-----------------------------------------------------------------------------
// CCharacter
//-----------------------------------------------------------------------------
class CCharacter
{
	// `bvp^[
	enum {
		STAND		= 0,// C
		WALK_R,			// s EO
		ATACK_01,		// U Uグ
		ATACK_02,		// U U肨낵

		SITDOWN		= 10,// Ⴊ
		DEAD		= 12,// Ⴊ
	};
	enum {
		CHAR_CHIP_COUNT = 15,
	};

public:
	// Aj[Vp^[
	enum{
		ANI_PTN_NONE = 0,			// Aj[V
		ANI_PTN_WALK_AT_START,		// Jns
		ANI_PTN_ATTACK,				// U
		ANI_PTN_ATTACK_BACK,		// U̖߂
	};

	stPlayerCharacterInfo	m_Param;	// p[^
	stStatusAtBattle		m_Status;	// 퓬̂ݕωXe[^X

	const char *m_lpzFileName;			// 摜t@C
	int		m_nPosX;					// \{ʒuX
	int		m_nPosY;					// \{ʒuY

protected:
	// VXef[^

	int		m_nHandle[CHAR_CHIP_COUNT];	// 摜nh
	int		m_nDispPicPtrn;				// \Ă`bvԍ		

	// Aj[V֘A
	int		m_nDispPosX;				// \ʒuX
	int		m_nDispPosY;				// \ʒuY
	int		m_nAnimationPtrn;			// Aj[Vp^[
	DWORD	m_dwFrameCount;				// t[JEg

	stCommandInfo	m_SysCommand;		// VXeR}h


	// lAj[V
	CNumberAnimation	*m_pNumAnime;		// lAj[V
	void GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth );

protected:

	// ATB|Cg
	void IncreaseATBValue( DWORD dwFrameCount );

public:
	CCharacter(void);
	virtual ~CCharacter(void);

	BOOL LoadGraph( void );
	void SetName( const char *pName );
	void Finalize( void );

	// t[XV
	void FrameMove( void );
	// `
	void Render( void );

	// \ʒuݒ
	void SetDispPos( int nX, int nY )
	{
		m_nDispPosX = m_nPosX = nX;
		m_nDispPosY = m_nPosY = nY;
	
	};
	// Ă邩
	BOOL IsAliving( void ) const
	{	return ( m_pNumAnime->IsDisplay() || 0 < m_Param.nHP);	};

	// s
	BOOL IsActing( void ) const
	{	return (m_pNumAnime->IsDisplay() || m_nAnimationPtrn != ANI_PTN_NONE );	};

	// HP̑
	void ChangeHitPoint( int iDiff );

	// Aj[Vp^[
	void StartAction( int nAniPaternNo, stCommandInfo *pCommandInfo );

	// ATB|Cg폜
	void ClearATBValue( void )
	{	m_Param.nATBValue = 0;	};
};
