//=============================================================================
// DisplayManager.h
//=============================================================================
#pragma once
#include <list>
#include "FrameWindow.h"

class CField;
class CCharacter;
class CEnemyPartyWindow;
class CPlayerPartyWindow;
class CMenuWindow;
class CInfoWindow;
class CItemWindow;

// J[\[h
enum {
	DISP_MODE_NONE = 0,			// J[\
	DISP_MODE_PLAYER_COMMAND,	// v[R}hI
	DISP_MODE_PLAYER_SELECT,	// ATB̂܂v[I
	DISP_MODE_SELECT_ITEM,		// v[Ij[
	DISP_MODE_ENEMY_SELECT,		// R}hΏۓGI
};
//-----------------------------------------------------------------------------
// CDisplayManager
//-----------------------------------------------------------------------------
class CDisplayManager
{
protected:
	// VXe
	std::list<CFrameWindow *> m_lstWnd;		// \ǗXg
	std::list<CMenuWindow *> m_lstActiveWnd;// ANeBu(L[͎)EBhEXg

	// EBhE
	CEnemyPartyWindow	*m_pEnemyPtWnd;		// Gp[eBEBhE
	CMenuWindow			*m_pCommandWnd;		// R}hEBhE
	CMenuWindow			*m_pSubCmdWnd;		// TuR}hEBhE
	CInfoWindow			*m_pInfoWnd;		// 񕶎\EBhE
	CItemWindow			*m_pItemWnd;		// ACeEBhE

	CPlayerPartyWindow	*m_pPartyWnd;		// p[eB\EBhE
	CField				*m_pField;			// tB[h(Q)
	CCharacter			*m_pPlayerChar[BATTLE_CHAR_COUNT_MAX];		// p[eB(Q)
	CEnemy				*m_pEnemy[BATTLE_ENEMY_COUNT_MAX];		// Gp[eB(Q)
	int					m_nEnemyCount;		// G̐

	// R}hΏۂ̃L킷}[N
	int					m_nMarkHandle;		// }[NG
	int					m_nMarkPosX;		// }[NʒuX
	int					m_nMarkPosY;		// }[NʒuY
	int					m_nMarkIndex;		// CfbNX(p[eBo)

	// J[\֌W
	int					m_nCursorHandle;	// J[\G
	int					m_nDispMode;		// J[\[h
	int					m_nCurPosX;			// J[\ʒuX
	int					m_nCurPosY;			// J[\ʒuY
	int					m_nCursorIndex;		// CfbNX(p[eBo^G)
	int					m_nCommandID;		// IR}hID


	void CheckMenuKeyInput( CManipulator *pMani );	// j[L[̓`FbN

	void CheckEnemySelectKeyInput( CManipulator *pMani );	// GIL[̓`FbN
	int GetEnemyCursor( int nKeyCode );

public:
	CDisplayManager(void);
	virtual ~CDisplayManager(void);

	BOOL Initialize( CCharacter **pPlayerChar, CEnemy **pEnemy, int nEnemyCount, CField *pField );
	void FrameMove( CManipulator *pMani );	// XV
	void ModeProc( CManipulator *pMani );	// J[\
	void Render( void );					// `

	void ShowMessage( const char *lpzText );
};

