//=============================================================================
// Enemy.cpp
//=============================================================================
#include "Stdinc.h"
#include "Enemy.h"
#include "NumberAnimation.h"
#include "BattleSystem.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEnemy::CEnemy(void)
	:m_pNumAnime( NULL ), m_nAnimationPtrn(ANI_PTN_NONE), m_dwFrameCount( 0 ), m_bDrawBlink( FALSE )
{
	// lAj[V
	m_pNumAnime = new CNumberAnimation();

	ZeroMemory( &m_SysCommand, sizeof(m_SysCommand) );
}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEnemy::~CEnemy(void)
{
	Finalize();

	
	if ( m_pNumAnime )
	{
		delete m_pNumAnime;
	}
}

//-----------------------------------------------------------------------------
// Initialize
// 
//-----------------------------------------------------------------------------
BOOL CEnemy::LoadGraph( void )
{
	char szFileName[MAX_PATH];

	sprintf_s( szFileName, sizeof(szFileName), "%s\\enemy_%03d.png", GRAPHICS_DIR_03, m_Param.nID );

	// wiGǂݍ
	m_nHandle = ::LoadGraph( szFileName );
	if ( m_nHandle == DX_FAILED )
	{
		CUtility::tERROR("摜ǂݍݎs [%s]", szFileName );
		return FALSE;
	}
	GetGraphSize( m_nHandle, &m_nGraphWidth, &m_nGraphHeight );

	return TRUE;
}
//-----------------------------------------------------------------------------
// Finalize
// I
//-----------------------------------------------------------------------------
void CEnemy::Finalize( void )
{
	DeleteGraph( m_nHandle );
}
//-----------------------------------------------------------------------------
// FrameMove
// XV
//-----------------------------------------------------------------------------
void CEnemy::FrameMove( void )
{
	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_NONE:			// Aj[V
		m_nDispPosX = m_nPosX;
		m_nDispPosY = m_nPosY;
		break;
	case ANI_PTN_WALK_AT_START:	// Jn
		m_nDispPosX += 4;
		if ( m_dwFrameCount == 25 )
		{
			StartAction( ANI_PTN_NONE, NULL );
		}
		break;
	case ANI_PTN_ATTACK:		// U
		// _
		m_bDrawBlink = ( m_dwFrameCount % 3 < 1 );
		if ( m_dwFrameCount == 20 )
		{
			// Ut[Ō v[ nParam1HP nParam2炷
			CBattleSystem::GetInstance()->ExpressCommandResult( COMMAND_SYSTEM_CHANGE_PLAYER_HP, m_SysCommand.nParam1, m_SysCommand.nParam2 );

			m_bDrawBlink = FALSE;
			StartAction( ANI_PTN_NONE, NULL );
		}
	}
	// lAj[V
	m_pNumAnime->FrameMove();

	// ATBl
	IncreaseATBValue( m_dwFrameCount );

	m_dwFrameCount ++;
}
//-----------------------------------------------------------------------------
// SelectCommand
// R}hI (AI)
//-----------------------------------------------------------------------------
int CEnemy::SelectCommand( int *pParam )
{
	// ToDo:
	*pParam = COMMAND_PARAM_RANDOM;	// _

	return COMMAND_ENEMY_ATTACK;
}

//-----------------------------------------------------------------------------
// Render
// _O
//-----------------------------------------------------------------------------
void CEnemy::Render( void )
{
	// `

	if ( m_bDrawBlink )
	{	// ]`	 : ToDo
		SetDrawBright( 255 , 0 , 0 );
		DrawGraph( m_nDispPosX, m_nDispPosY, m_nHandle, TRUE );
		SetDrawBright( 255 , 255 , 255 );
	}
	else
	{	// ʏ`
		DrawGraph( m_nDispPosX, m_nDispPosY, m_nHandle, TRUE );
	}

	// HPAj[V
	m_pNumAnime->Render();
}
//-----------------------------------------------------------------------------
// GetCursorDispPos
// J[\\ʒu擾
//-----------------------------------------------------------------------------
void CEnemy::GetCursorDispPos( int *pX, int *pY )
{
	*pX = m_nPosX - 8;
	*pY = m_nPosY + (m_nGraphHeight / 2) - 8;
}
//-----------------------------------------------------------------------------
// GetNumAnimeDispPos
// Aj[V\ʒu擾
//-----------------------------------------------------------------------------
void CEnemy::GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth )
{
	*pX = m_nPosX + ((m_nGraphWidth - iDispWidth) / 2);
	*pY = m_nPosY + m_nGraphHeight - 12;
}
//-----------------------------------------------------------------------------
// ChangeHitPoint
// HP
//-----------------------------------------------------------------------------
void CEnemy::ChangeHitPoint( int iDiff )
{
	// HPAj[Vݒ
	DWORD dwColor;
	if ( 0 <= iDiff )
	{	// 0Ɛ̒l
		dwColor = GetColor(255,255,255);
	}
	else
	{	// ̒l(HP)
		dwColor = GetColor(96,255,96);
	}

	int iX,iY;
	int iWidth = CNumberAnimation::GetDispWidth( iDiff );
	GetNumAnimeDispPos( &iX, &iY, iWidth );
	m_pNumAnime->StartAction( iX, iY, iDiff, dwColor );

	// HP炷
	m_nHP -= iDiff;
	if ( m_nHP < 0 )
		m_nHP = 0;
}
//-----------------------------------------------------------------------------
// StartAction
// Aj[Vp^[ݒ
//-----------------------------------------------------------------------------
void CEnemy::StartAction( int nPaternNo, stCommandInfo *pCommandInfo )
{
	m_nAnimationPtrn = nPaternNo;
	if ( pCommandInfo )
		m_SysCommand = *pCommandInfo;
	else
		RtlZeroMemory( &m_SysCommand, sizeof(m_SysCommand) );

	// Aj[VX^[gʒuݒ
	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_WALK_AT_START:	// Jns
		m_nDispPosX = m_nPosX - 100;
		break;

	default:
		// {ʒuɖ߂
		m_nDispPosX = m_nPosX;
		m_nDispPosY = m_nPosY;
	}

	// t[JE^Zbg
	m_dwFrameCount = 0;

}
//-----------------------------------------------------------------------------
// IncreaseATBValue
// ATBl
//-----------------------------------------------------------------------------
void CEnemy::IncreaseATBValue( DWORD dwFrameCount )
{
	if ( dwFrameCount % 6 == 1 )	// ToDo : v[肿ƒx
	{
		// ToDo : Xe[^Xɉ ATBlXV
		if ( m_Param.nATBValue < ATB_VALUE_MAX )
		{
			++ m_Param.nATBValue;
		}
		else
		{
			m_Param.nATBValue = ATB_VALUE_MAX;
		}
	}
}
