//=============================================================================
// Enemy.h
//=============================================================================
#pragma once

#include "NumberAnimation.h"

//-----------------------------------------------------------------------------
// CEnemy
//-----------------------------------------------------------------------------
class CEnemy
{
protected:
	int		m_nHandle;					// Gnh

	int		m_nGraphWidth;				// G̃TCY
	int		m_nGraphHeight;
	BOOL	m_bDrawBlink;				// _

	// Aj[V֘A
	int		m_nDispPosX;				// \ʒuX
	int		m_nDispPosY;				// \ʒuY
	int		m_nAnimationPtrn;			// Aj[Vp^[
	DWORD	m_dwFrameCount;				// t[JEg

	stCommandInfo	m_SysCommand;		// VXeR}h

public:
	enum{
		ANI_PTN_NONE = 0,			// Aj[V
		ANI_PTN_WALK_AT_START,		// Jns
		ANI_PTN_ATTACK,				// U
	};

	stEnemyInfo	m_Param;	// p[^

	// p^O (퓬ϓ)
	int m_nHP;			// MaxHP
	int m_nMP;			// MaxMP
	// Xe[^X
	BOOL m_bPoison;
	BOOL m_bFrog;
	BOOL m_bParalyze;
	BOOL m_bSmall;
	BOOL m_bStone;
	BOOL m_bBlind;
	BOOL m_bZombi;
	BOOL m_bSilence;


	int		m_nPosX;						// \ʒuX
	int		m_nPosY;						// \ʒuY
	
	// lAj[V
	CNumberAnimation	*m_pNumAnime;		// lAj[V
	void GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth );

public:
	CEnemy(void);
	virtual ~CEnemy(void);

	// 
	BOOL LoadGraph( void );
	void Finalize( void );

	void FrameMove( void );
	// _O
	void Render( void );
	// \ʒuݒ
	void SetDispPos( int nX, int nY )
	{
		m_nDispPosX = m_nPosX = nX;
		m_nDispPosY = m_nPosY = nY;
	};

	void GetCursorDispPos( int *pX, int *pY );

	// HP̑
	void ChangeHitPoint( int iDiff );

	// Ă邩
	BOOL IsAliving( void ) const
	{	return ( m_pNumAnime->IsDisplay() || 0 < m_nHP);	};
	// s
	BOOL IsActing( void ) const
	{	return (m_pNumAnime->IsDisplay() || m_nAnimationPtrn != ANI_PTN_NONE );	};

	// Aj[Vp^[
	void StartAction( int nPaternNo, stCommandInfo *pCommandInfo );

	// ATB|Cg
	void IncreaseATBValue( DWORD dwFrameCount );
	// ATB|Cg폜
	void ClearATBValue( void )
	{	m_Param.nATBValue = 0;	};

	// R}hI
	int SelectCommand( int *pParam );

};